package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.Dynamic;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import com.ekexiu.portal.po.Article;

@DAO
public abstract class ArticleDao {
	@Insert
	public abstract int insert(Connection con, Article article) throws SQLException;
	
	@Update
	@Dynamic
	public abstract int update(Connection con, Article article) throws SQLException;
	
	@UpdateWith
	@From(Article.class)
	public abstract int updateSubject(Connection con, @Set String subject, String articleId) throws SQLException;
	
	@UpdateWith
	@From(Article.class)
	public abstract int updateIndustry(Connection con, @Set String industry, String articleId) throws SQLException;
	
	@DeleteWith
	@From(Article.class)
	public abstract int delete(Connection con, String articleId) throws SQLException;
	
	@DeleteWith
	@From(Article.class)
	public abstract int deletePro(Connection con, String professorId) throws SQLException;
	
	@SelectList
	@OrderBy(" ORDER BY MODIFY_TIME DESC ")
	public abstract List<Article> queryPro(Connection con, String professorId) throws SQLException;
	
	@SelectOne
	@Nullable
	public abstract Article queryOne(Connection con, String articleId) throws SQLException;

}
