package com.ekexiu.portal.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.BaseOrganization;
import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.DescpSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;

@Uniques(@Unique(name="ORGANIZATION_NAME_UN",clolumns="name"))
@PrimaryKey("id")
@Table
public class Organization extends BaseOrganization implements CreateTimeSupported,ModifyTimeSupported,DescpSupported{

	/**
	 * 企业官网
	 */
	private String orgUrl;
	/**
	 * 创立时间
	 */
	private String foundTime;
	private String province;
	private String city;
	private String subject;
	private String industry;
	/**
	 * 企业规模
	 */
	private String orgSize;
	/**
	 * 企业资质
	 */
	private String qualification;
	/**
	 * 是否入驻
	 */
	private String isJoin;
	/**
	 * 认证状态
	 */
	private String authStatus;
	private String descp;
	private String createTime;
	private String modifyTime;

	@Column(DE.String_de)
	public String getOrgUrl() {
		return orgUrl;
	}
	public void setOrgUrl(String orgUrl) {
		this.orgUrl = orgUrl;
	}
	@Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(8)",nullable=true,insertable=true,renewable=true,queryable=true)
	public String getFoundTime() {
		return foundTime;
	}
	public void setFoundTime(String foundTime) {
		this.foundTime = foundTime;
	}
	@Column(DE.String_de)
	public String getProvince() {
		return province;
	}
	public void setProvince(String province) {
		this.province = province;
	}
	@Column(DE.String_de)
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getSubject() {
		return subject;
	}
	public void setSubject(String subject) {
		this.subject = subject;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getIndustry() {
		return industry;
	}
	public void setIndustry(String industry) {
		this.industry = industry;
	}
	@Column(DE.SingleChar)
	public String getOrgSize() {
		return orgSize;
	}
	public void setOrgSize(String orgSize) {
		this.orgSize = orgSize;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getQualification() {
		return qualification;
	}
	public void setQualification(String qualification) {
		this.qualification = qualification;
	}
	@Column(value=DE.SingleChar,renewable=false)
	public String getIsJoin() {
		return isJoin;
	}
	public void setIsJoin(String isJoin) {
		this.isJoin = isJoin;
	}
	@Column(value=DE.SingleChar,renewable=false)
	public String getAuthStatus() {
		return authStatus;
	}
	public void setAuthStatus(String authStatus) {
		this.authStatus = authStatus;
	}
	public String getDescp() {
		return descp;
	}
	public void setDescp(String descp) {
		this.descp = descp;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
}
