package com.ekexiu.portal.service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.AuthApplyDao;
import com.ekexiu.portal.dao.OrgDao;
import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.po.AuthApply;
import com.ekexiu.portal.pojo.AuthApplyInfo;

@Path("/authApply")
public class AuthApplyService {
	@Autowrie
	private AuthApplyDao authApplyDao;
	@Autowrie
	private AuthImageService authImageService;
	@Autowrie
	private ProfessorDao professorDao;
	@Autowrie
	private OrgDao orgDao;

	public AuthApplyDao getAuthApplyDao() {
		return authApplyDao;
	}

	public void setAuthApplyDao(AuthApplyDao authApplyDao) {
		this.authApplyDao = authApplyDao;
	}
	
	public AuthImageService getAuthImageService() {
		return authImageService;
	}

	public void setAuthImageService(AuthImageService authImageService) {
		this.authImageService = authImageService;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	public OrgDao getOrgDao() {
		return orgDao;
	}

	public void setOrgDao(OrgDao orgDao) {
		this.orgDao = orgDao;
	}

	@Post
	@Path("/realName")
	public void realNameAuth(@JdbcConn(true) Connection con,AuthApply authApply,String[] fns) throws SQLException, IOException{
		String authApplyId = StringUtil.buildUUID();
		authApply.setAuthApplyId(authApplyId);
		authApply.setApplyType(1);
		authApply.setSolveStatus(1);
		this.authApplyDao.insert(con, authApply);
		this.professorDao.updateAuthStatus(con, authApply.getProfessorId(), 1);
		for (String fn : fns) {
			this.authImageService.insertImg(con, authApplyId, fn);
		}
	}
	
	@Post
	@Path("/expert")
	public void expertAuth(@JdbcConn(true) Connection con,AuthApply authApply,String[] fns)throws SQLException, IOException{
		String authApplyId = StringUtil.buildUUID();
		authApply.setAuthApplyId(authApplyId);
		authApply.setApplyType(2);
		authApply.setSolveStatus(1);
		this.authApplyDao.insert(con, authApply);
		this.professorDao.updateAuthStatusExpert(con, authApply.getProfessorId(), 1);
		for (String fn : fns) {
			this.authImageService.insertImg(con, authApplyId, fn);
		}
	}
	
	@Post
	@Path("/org")
	public void orgAuth(@JdbcConn(true) Connection con,AuthApply authApply,String[] fns)throws SQLException, IOException{
		String authApplyId = StringUtil.buildUUID();
		authApply.setAuthApplyId(authApplyId);
		authApply.setApplyType(3);
		authApply.setSolveStatus(1);
		this.authApplyDao.insert(con, authApply);
		for (String fn : fns) {
			this.authImageService.insertImg(con, authApplyId, fn);
		}
	}
	
	@Post
	@Path("/state")
	public void updateState(@JdbcConn(true) Connection con,String id,Integer state,Integer auth,String professorId) throws SQLException{
		this.authApplyDao.updateSolveStatus(con,state,id);
		if(auth==1){
			this.professorDao.updateAuthStatus(con, professorId, state);
		}else if(auth==2){
			this.professorDao.updateAuthStatusExpert(con, professorId, state);
			if(state==3){
				this.professorDao.updateAuthType(con, professorId, 1);
			}
		}else if(auth==3){
			this.orgDao.updateAuthStatus(con, professorId, state+"");
		}
	}
	
	@Get
	@Path("/qaRealName")
	public List<AuthApplyInfo> queryRealName(@JdbcConn Connection con) throws SQLException{
		return this.authApplyDao.queryInfo(con, 1);
	}
	
	@Get
	@Path("/qaExpert")
	public List<AuthApplyInfo> queryExpert(@JdbcConn Connection con)throws SQLException{
		return this.authApplyDao.queryInfo(con, 2);
	}
	
	@Get
	@Path("/qaOrg")
	public List<AuthApply> queryOrg(@JdbcConn Connection con)throws SQLException{
		return this.authApplyDao.queryByType(con, 3);
	}
	
	@Get
	@Path("/info/{id}")
	public AuthApplyInfo query(@JdbcConn Connection con,@PathVar String id) throws SQLException{
		return this.authApplyDao.queryInfo(con, id);
	}
}
