package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.LeaveWordDao;
import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.po.LeaveWord;
import com.ekexiu.portal.pojo.EditProfessor;

@Path("/leaveWord")
public class LeaveWordService {
	public static final String MAX_CREATETIME="9";

	@Autowrie
	private LeaveWordDao leaveWordDao;
	@Autowrie
	private ProfessorDao professorDao;
	@Autowrie
	private ImageService imageService;

	public LeaveWordDao getLeaveWordDao() {
		return leaveWordDao;
	}

	public void setLeaveWordDao(LeaveWordDao leaveWordDao) {
		this.leaveWordDao = leaveWordDao;
	}
	
	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con,LeaveWord word) throws SQLException{
		String id = StringUtil.buildUUID();
		word.setId(id);
		word.setOrderKey(System.nanoTime());
		this.leaveWordDao.insert(con, word);
		return id;
	}
	
	@Get
	@Path("/ql")
	public List<LeaveWord> query(@JdbcConn Connection con,String articleId,@DefaultValue("com.ekexiu.portal.service.LeaveWordService.MAX_CREATETIME")  String createTime,@DefaultValue("Long.MAX_VALUE") long orderKey,@DefaultValue("10") int rows) throws SQLException{
		List<LeaveWord> leaveWords = this.leaveWordDao.query(con, articleId, createTime, orderKey, rows);
		if(!leaveWords.isEmpty()){
			for (LeaveWord leaveWord : leaveWords) {
				EditProfessor professor = this.professorDao.queryBaseInfo(con, leaveWord.getSender());
				professor.setHasHeadImage(this.imageService.hasProfessorImage(leaveWord.getSender()));
				leaveWord.setProfessor(professor);
			}
		}
		return leaveWords;
	}
}
