package com.ekexiu.portal.service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.OperateServiceFileDao;
import com.ekexiu.portal.dao.OperateServiceLogDao;
import com.ekexiu.portal.po.OperateServiceLog;

@Path("/operateServiceLog")
public class OperateServiceLogService {
	@Autowrie
	private OperateServiceLogDao serviceLogDao;
	@Autowrie
	private OperateServiceFileDao serviceFileDao;
	@Autowrie
	private OperateServiceFileService serviceFileService;
	public OperateServiceLogDao getServiceLogDao() {
		return serviceLogDao;
	}
	public void setServiceLogDao(OperateServiceLogDao serviceLogDao) {
		this.serviceLogDao = serviceLogDao;
	}
	public OperateServiceFileDao getServiceFileDao() {
		return serviceFileDao;
	}
	public void setServiceFileDao(OperateServiceFileDao serviceFileDao) {
		this.serviceFileDao = serviceFileDao;
	}
	public OperateServiceFileService getServiceFileService() {
		return serviceFileService;
	}
	public void setServiceFileService(OperateServiceFileService serviceFileService) {
		this.serviceFileService = serviceFileService;
	}
	
	@Post
	@Path
	public String add(@JdbcConn(true) Connection con,OperateServiceLog serviceLog)throws SQLException, IOException{
		String serviceLogId = StringUtil.buildUUID();
		serviceLog.setServiceLogId(serviceLogId);
		this.serviceLogDao.insert(con, serviceLog);
		return serviceLogId;
	}
	
	@Get
	@Path("/queryOne")
	public OperateServiceLog queryOne(@JdbcConn Connection con,String serviceLogId)throws SQLException{
		OperateServiceLog serviceLog = this.serviceLogDao.queryOne(con, serviceLogId);
		serviceLog.setOperateServiceFiles(this.serviceFileDao.queryByServiceLogId(con, serviceLogId));
		return serviceLog;
	}
	
	@Get
	@Path("/queryByServiceUser")
	public List<OperateServiceLog> queryByServiceUser(@JdbcConn Connection con,String serviceUser)throws SQLException{
		return this.serviceLogDao.queryByServiceUser(con, serviceUser);
	}
	
}
